package com.eactive.eai.rms.bap.manage.comm.adapter;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

import com.eactive.eai.agent.command.CommonCommand;
import com.eactive.eai.rms.common.base.BapBaseAnnotationController;
import com.eactive.eai.rms.common.util.CamelCaseUtil;
import com.eactive.eai.rms.common.vo.JsonPageVo;
import com.google.gson.Gson;

@Controller
public class BapAdapterController extends BapBaseAnnotationController  {

	@Autowired
	@Qualifier("bapAdapterService")
	private BapAdapterService service;
	
	@Autowired
	private BapAdapterSqlService sqlService;
	
	@RequestMapping(value= "/bap/admin/adapter/adapterMan.view")
	public String viewList(HttpServletRequest request, @RequestParam(value = "cmd", required = false ) String cmd ) throws Exception {
		if (cmd == null || "LIST".equals(cmd.toUpperCase())){
			cmd = "";
		}else {
			cmd = CamelCaseUtil.converCamelCase(cmd);
		}
		String path = request.getServletPath();
		return path.split("[.]")[0]+cmd;
	}
	
	/**
	 * @param request
	 * @param response
	 * @throws Exception
	 */
	@RequestMapping(value= "/bap/admin/adapter/adapterMan.json", params = "cmd=LIST")
	public ModelAndView selectList(HttpServletRequest request,
			JsonPageVo pageVo ,String searchAdptrBzwkGroupName, String searchAdptrBzwkGroupDesc) throws Exception {
		
		HashMap<String, Object> map = new HashMap<String, Object>();
		if (searchAdptrBzwkGroupName != null && searchAdptrBzwkGroupDesc != null) {
			map = service.selectList( pageVo.getStartNum(), pageVo.getEndNum(), searchAdptrBzwkGroupName, searchAdptrBzwkGroupDesc);
		}
		
		pageVo.setTotalCount((Integer)map.get("totalCount"));
		
		Map<String, Object> resultMap = new HashMap<String, Object>();
		resultMap.put("total"  , pageVo.getTotal());  //전체 페이지수
		resultMap.put("page"   , pageVo.getPage());   //현재 페이지수
		resultMap.put("records", pageVo.getTotalCount());//전체 레코드건수	
		resultMap.put("rows"   , map.get("list"));
		
		ModelAndView modelAndView = new ModelAndView("jsonView",resultMap);		
		return modelAndView;
		
	}

	@RequestMapping(value= "/bap/admin/adapter/adapterMan.json",params = "cmd=DETAIL")
	public ModelAndView selectDetail(HttpServletRequest request,
			HttpServletResponse response,String adptrBzwkGroupName) throws Exception {
		
		HashMap<String, Object> map = service.selectDetail(adptrBzwkGroupName);

		ModelAndView modelAndView = new ModelAndView("jsonView",map);	
		
		return modelAndView;
	}
	@RequestMapping(value= "/bap/admin/adapter/adapterMan.json",params = "cmd=INSERT")
	public String insert(HttpServletRequest request,
			HttpServletResponse response,@RequestParam HashMap<String,Object> map, String gridData ) throws Exception {
    	Gson gson = new Gson();
    	@SuppressWarnings("unchecked")
		HashMap<String, Object>[] list = gson.fromJson(gridData, HashMap[].class);
    	service.insert(map,list);
		CommonCommand command = new CommonCommand("com.eactive.eai.agent.adapter.UpdateAdapterGroupCommand",(String)map.get("adptrBzwkGroupName"));
		agentUtilService.broadcast(command);
		command = new CommonCommand("com.eactive.eai.agent.property.UpdatePropertyCommand",(String)map.get("prptyGroupName"));
		agentUtilService.broadcast(command);
		
    	return null;            
		
	}	
	@RequestMapping(value= "/bap/admin/adapter/adapterMan.json",params = "cmd=UPDATE")
	public String update(HttpServletRequest request,
			HttpServletResponse response,@RequestParam HashMap<String,Object> map, String gridData ) throws Exception {
    	Gson gson = new Gson();
    	@SuppressWarnings("unchecked")
		HashMap<String, Object>[] list = gson.fromJson(gridData, HashMap[].class);
    	service.update(map,list);
		CommonCommand command = new CommonCommand("com.eactive.eai.agent.adapter.UpdateAdapterGroupCommand",(String)map.get("adptrBzwkGroupName"));
		agentUtilService.broadcast(command);
		command = new CommonCommand("com.eactive.eai.agent.property.UpdatePropertyCommand",(String)map.get("prptyGroupName"));
		agentUtilService.broadcast(command);
		
		return null;
		
	}
	@RequestMapping(value= "/bap/admin/adapter/adapterMan.json",params = "cmd=DELETE")
	public String delete(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String,Object> map ) throws Exception {

		String adptrBzwkGroupName = map.get("adptrBzwkGroupName").toString();
		String prptyGroupName = map.get("prptyGroupName").toString();
		service.delete(map);
		CommonCommand command = new CommonCommand("com.eactive.eai.agent.adapter.RemoveAdapterGroupCommand", adptrBzwkGroupName);
		agentUtilService.broadcast(command);
		command = new CommonCommand("com.eactive.eai.agent.adapter.RemoveAdapterGroupCommand",prptyGroupName);
		agentUtilService.broadcast(command);
		return null;
	}
	@SuppressWarnings("unchecked")
	@RequestMapping(value= "/bap/admin/adapter/adapterMan.json",params = "cmd=LIST_DELETE")
	public String deleteList(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String,Object> map ) throws Exception {

		for (String adptrBzwkGroupName : map.get("adptrBzwkGroupNameList").toString().split(",")) {
			HashMap<String, Object> adptrBzwkGroup = service.selectDetail(adptrBzwkGroupName);
			HashMap<String, Object>   detail      = (HashMap<String, Object>)adptrBzwkGroup.get("detail");
			String prptyGroupName = detail.get("PRPTYGROUPNAME").toString();
			
			HashMap<String,Object> adptrMap = new HashMap<String,Object>();
			adptrMap.put("adptrBzwkGroupName", adptrBzwkGroupName);
			adptrMap.put("prptyGroupName", prptyGroupName);
			service.delete(adptrMap);
			CommonCommand command = new CommonCommand("com.eactive.eai.agent.adapter.RemoveAdapterGroupCommand", adptrBzwkGroupName);
			agentUtilService.broadcast(command);
			command = new CommonCommand("com.eactive.eai.agent.adapter.RemoveAdapterGroupCommand",prptyGroupName);
			agentUtilService.broadcast(command);
		}
		return null;
	}	
	@RequestMapping(value= "/bap/admin/adapter/adapterMan.json",params = "cmd=LIST_DOWNLOAD_SQL")
	public ModelAndView downloadSql(HttpServletRequest request,
		HttpServletResponse response,@RequestParam HashMap<String,Object> map) throws Exception {		

//    	ModelAndView modelAndView = new ModelAndView("jsonView",service.mkInsertSqlForBapAdptr(map));	
		
		String sql = sqlService.bapAdapterSql(map);	
		
		Map<String, String> resultMap = new HashMap<>();
		resultMap.put("sql", sql);
		
		ModelAndView modelAndView = new ModelAndView("jsonView", resultMap);
		return modelAndView;
	}
	@RequestMapping(value= "/bap/admin/adapter/adapterMan.view",params = "cmd=LIST_FILE_DOWNLOAD")
	public String fileDownload(HttpServletRequest request) throws Exception {
		
		return "/bap/admin/common/filedownload";
	}
}